//This is the Draw Program conversion to Pelles C
// Full Screen Direct Draw 800x600

// INCLUDES ///////////////////////////////////////////////
#define WIN32_LEAN_AND_MEAN

// You need to tell DirectInput if you're using v7.0 or less
#define DIRECTINPUT_VERSION 0x0700

#define INITGUID

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h> 
#include <ddraw.h>
#include <dinput.h>
#include "Binary Draw 800.h"

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"

// default screen size
#define SCREEN_WIDTH    800  // size of screen
#define SCREEN_HEIGHT   600
#define SCREEN_BPP      8    // bits per pixel
#define MAX_COLORS      256  // maximum colors

// TYPES //////////////////////////////////////////////////////

// basic unsigned types
typedef unsigned short USHORT;
typedef unsigned short WORD;
typedef unsigned char  UCHAR;
typedef unsigned char  BYTE;

// MACROS /////////////////////////////////////////////////
#define KEYDOWN(vk_code) ((GetAsyncKeyState(vk_code) & 0x8000) ? 1 : 0)
#define KEYUP(vk_code)   ((GetAsyncKeyState(vk_code) & 0x8000) ? 0 : 1)

// initializes a direct draw struct
#define DDRAW_INIT_STRUCT(ddstruct) { memset(&ddstruct,0,sizeof(ddstruct)); ddstruct.dwSize=sizeof(ddstruct); }

// GLOBALS ////////////////////////////////////////////////
HWND      main_window_handle = NULL; // globally track main window
HINSTANCE hinstance_app      = NULL; // globally track hinstance
int       window_closed      = 0;    // tracks if window is closed
char buffer[80];                // used to print text
// directinput globals
LPDIRECTINPUT7        lpdi      = NULL;    // dinput object
LPDIRECTINPUTDEVICE7  lpdikey   = NULL;    // dinput keyboard
LPDIRECTINPUTDEVICE7  lpdimouse = NULL;    // dinput mouse
UCHAR        keystate[256]; // contains keyboard state table
DIMOUSESTATE mouse_state;         // contains state of mouse
//Directdraw stuff
LPDIRECTDRAW          lpdd         = NULL;   // dd object
LPDIRECTDRAW7         lpdd7        = NULL;   // dd7 object
LPDIRECTDRAWSURFACE7  lpddsprimary = NULL;   // dd primary surface
LPDIRECTDRAWSURFACE7  lpddsback    = NULL;   // dd back surface
LPDIRECTDRAWPALETTE   lpddpal      = NULL;   // a pointer to the created dd palette
PALETTEENTRY          palette[256];          // color palette
PALETTEENTRY          save_palette[256];     // used to save palettes
DDSURFACEDESC2        ddsd;                  // a direct draw surface description struct
DDBLTFX               ddbltfx;               // used to fill
DDSCAPS2              ddscaps;               // a direct draw surface capabilities struct
HRESULT               ddrval;                // result back from dd calls

int mouse_x,                    // used to track mouse
    mouse_y;
    
UCHAR mouse_color=15;          // color of mouse brush

int pixnum = 0;				//used to show old pix
int nextmove = 0;			//used with mouse switch in Game Main
int done = 0;				//used with load switch
int number = 0;
static BOOL kup = TRUE;
int pixnew = 0;			//used with load_new
int new_color = 255;	//used with Draw_Pix
static BOOL quad = FALSE;			//used as a toggle for quad drawing
BOOL quad_pressed = TRUE;
char loadname[25] = "test1.pix";
char savename[25]  = "test1.pix";
int wide = 102;
int high = 78;
char filestring[25];
char fileload[25];
char filesave[25];
char fileend[5] = ".pix";
int keydone = 0;
int settingsdone = 0;
char numstring[4];
char ht[3];
char wd[3];
char pixstring[300];
int pixdone = 0;
int offset = 0;
int oldwide = 0;
int oldhigh = 0;
// these are overwritten globally by DD_Init()
int screen_width  = SCREEN_WIDTH,            // width of screen
    screen_height = SCREEN_HEIGHT,           // height of screen
    screen_bpp    = SCREEN_BPP;              // bits per pixel

//PROTOTYPES///////////////////////
int Game_Init(void);
int Game_Main(void);
int Game_Shutdown(void);
void Plot8(int x, int y, UCHAR color, UCHAR *buffer, int mempitch);
int Screen_lines_old(LPDIRECTDRAWSURFACE7 lpdds);
int DDraw_Fill_Surface(LPDIRECTDRAWSURFACE7 lpdds,int color);
int Load_Old_Image(int pixnum);
int Draw_Text_GDI(char *text, int x, int y, COLORREF color, LPDIRECTDRAWSURFACE7 lpdds); 
int Screen_grid(LPDIRECTDRAWSURFACE7 lpdds);
int Screen_lines_new(LPDIRECTDRAWSURFACE7 lpdds);
int ShowBitmapFromFile(LPDIRECTDRAWSURFACE7 lpdds, int xDest, int yDest, LPCSTR szBitmap);
int Build_colors(void);
int Draw_Pix(int new_color);
int Draw_Quad(int new_color);
int Save_New_Image(LPDIRECTDRAWSURFACE7 lpdds);
int Load_New_Image(int pixnew);
void Keyreader(void);
void Rect_Erase(int section);
void Numbers(void);
void Load_Num(void);
void WriteSaveName(void);
void LoadSaveName(void);
void LoadLoadName(void);
void WriteLoadName(void);
void WriteWideHigh(void);
void LoadWideHigh(void);

// FUNCTIONS //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
	// this is the main message handler of the system
	PAINTSTRUCT		ps;		// used in WM_PAINT
	// what is the message 
	switch(msg)
		{	
		case WM_CREATE: 
			{
			// do initialization stuff here
			// return success
			return(0);
			} break;

			case WM_PAINT: 
			{
			// simply validate the window 
        		BeginPaint(hwnd,&ps);	 
			// end painting
			EndPaint(hwnd,&ps);

			// return success
			return(0);
   			} break;

		case WM_DESTROY: 
			{

			// kill the application, this sends a WM_QUIT message 
			PostQuitMessage(0);

			// return success
			return(0);
			} break;

		default:break;

		} // end switch

	// process any messages that we didn't take care of 
	return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc
//////////////////////

int Game_Main(void)
{
	MSG msg;
	int a = 0;
	int t;
	RECT SettingsRect;
	SettingsRect.top = 440;
	SettingsRect.left = 420;
	SettingsRect.bottom = 460;
	SettingsRect.right = 654;

	// make sure this isn't executed again
	if (window_closed)
		return(0);
	//clear memory for strings
	memset(&filestring,0,sizeof(filestring));
	memset(&fileload,0,sizeof(fileload));
	memset(&filesave,0,sizeof(filesave)); 

	do
	{
		// for now test if user is hitting ESC and send WM_CLOSE
		if (KEYDOWN(VK_ESCAPE))
		{
			PostMessage(main_window_handle,WM_CLOSE,0,0);
			window_closed = 1;
		}
		PeekMessage(&msg,NULL,0,0,PM_REMOVE)	;	
		{ 
			// test if this is a quit
			if (msg.message == WM_QUIT)
				break;
			// translate any accelerator keys
			TranslateMessage(&msg);
			// send the message to the window proc
			DispatchMessage(&msg);
		} // end if

		ShowBitmapFromFile(lpddsprimary, 160, 500, "load_button.bmp");
		ShowBitmapFromFile(lpddsprimary, 285, 500, "save_button.bmp");
		ShowBitmapFromFile(lpddsprimary, 410, 500, "clear_button.bmp");
		ShowBitmapFromFile(lpddsprimary, 535, 500, "quit_button.bmp");
		ShowBitmapFromFile(lpddsprimary, 160, 540, "settings_button.bmp");
		ShowBitmapFromFile(lpddsprimary, 410, 540, "offset.bmp");
		if(quad)
			ShowBitmapFromFile(lpddsprimary, 285, 540, "quad_on_button.bmp");
		else
			ShowBitmapFromFile(lpddsprimary, 285, 540, "quad_off_button.bmp");
		//this builds upper left frame
		Screen_lines_old(lpddsprimary);
		Screen_grid(lpddsprimary);
		Screen_lines_new(lpddsprimary);
		Draw_Text_GDI("Load File Name:", 150, 410, RGB(255, 255, 255), lpddsprimary);
		sprintf(buffer, "%s", loadname);
		Draw_Text_GDI(buffer, 270, 410, RGB(255, 255, 255), lpddsprimary);
		Draw_Text_GDI("Save File Name:", 150, 430, RGB(255, 255, 255), lpddsprimary);
		sprintf(buffer, "%s", savename);
		Draw_Text_GDI(buffer, 270, 430, RGB(255, 255, 255), lpddsprimary);
		Draw_Text_GDI("Width:", 150, 450, RGB(255, 255, 255), lpddsprimary);
		sprintf(buffer, "%d", wide);
		Draw_Text_GDI(buffer, 205, 450, RGB(255, 255, 255), lpddsprimary);
		Draw_Text_GDI("Height:", 245, 450, RGB(255, 255, 255), lpddsprimary);
		sprintf(buffer, "%d", high);
		Draw_Text_GDI(buffer, 311, 450, RGB(255, 255, 255), lpddsprimary);
		Draw_Text_GDI("Offset:", 150, 470, RGB(255, 255, 255), lpddsprimary);
		sprintf(buffer, "%d", offset);
		Draw_Text_GDI(buffer, 220, 470, RGB(255, 255, 255), lpddsprimary);
		Build_colors();
		// get the input from the mouse
		lpdimouse->lpVtbl->GetDeviceState(lpdimouse, sizeof(DIMOUSESTATE), (LPVOID)&mouse_state);
		// move the mouse cursor
		mouse_x+=(mouse_state.lX); 
		mouse_y+=(mouse_state.lY); 
		SetCursorPos(mouse_x, mouse_y);
		// first x boundaries
		if(mouse_x >= 795)
		{
			mouse_x = 795;
			SetCursorPos(mouse_x, mouse_y);
		}
		if (mouse_x < 0)
		{
			mouse_x = 0;
			SetCursorPos(mouse_x, mouse_y);
		}

		// now the y boundaries
		if(mouse_y >= 595)
		{
			mouse_y = 595;
			SetCursorPos(mouse_x, mouse_y);
		}
		if (mouse_y < 0)
		{
			mouse_y = 0;
			SetCursorPos(mouse_x, mouse_y);
		}

		// test what the user is doing with the mouse
		if((mouse_y < 396)&&(mouse_state.rgbButtons[0])&&(quad==FALSE))
			Draw_Pix(new_color);
		if((mouse_y < 396)&&(mouse_state.rgbButtons[0])&&(quad==TRUE))
			Draw_Quad(new_color);
		
		//this checks button area and is left button down
		if((mouse_y > 500)&&(mouse_state.rgbButtons[0]))
		{  //check buttons
			if (((mouse_x > 160)&&(mouse_x < 249))&&((mouse_y > 500)&&(mouse_y < 523)))
				nextmove = 1;  //Load
			if (((mouse_x > 285)&&(mouse_x < 374))&&((mouse_y > 500)&&(mouse_y < 523)))
				nextmove = 2;  //Save
			if (((mouse_x > 410)&&(mouse_x < 499))&&((mouse_y > 500)&&(mouse_y < 523)))
				nextmove = 3;  //Clear
			if (((mouse_x > 535)&&(mouse_x < 624))&&((mouse_y > 500)&&(mouse_y < 523)))
				nextmove = 4;  //Quit
			if (((mouse_x > 160)&&(mouse_x < 249))&&((mouse_y > 540)&&(mouse_y < 563)))
				nextmove = 5;  //Settings
			if(((mouse_x > 285)&&(mouse_x < 374))&&((mouse_y > 540)&&(mouse_y < 563)))
			{
				if((quad == FALSE)&&(quad_pressed == TRUE))
				{
					quad = TRUE; //turn quad on
					PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
					ShowBitmapFromFile(lpddsprimary, 285, 540, "quad_on_button.bmp");
					if(quad_pressed)
						quad_pressed = FALSE;
				}
				if((quad == TRUE)&&(quad_pressed == TRUE)) 
				{
					quad = FALSE;  //turn quad off
					PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
					ShowBitmapFromFile(lpddsprimary, 285, 540, "quad_off_button.bmp");
					if(quad_pressed)
						quad_pressed = FALSE;
				}
			}
			if(((mouse_x > 410)&&(mouse_x < 499))&&((mouse_y > 540)&&(mouse_y < 563)))
				nextmove = 6;  //Offset
		}
		if(!mouse_state.rgbButtons[0])
			quad_pressed = TRUE;
		
		switch (nextmove)
		{
			case 1:
			{
			//Load
			//get an image to load
				PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
				ShowBitmapFromFile(lpddsprimary, 160, 500, "load_down_button.bmp");
				Rect_Erase(6); 
				Draw_Text_GDI("Load Pix Number:", 420, 410, RGB(255, 0, 0), lpddsprimary);					
				Load_Num();
				pixnum = atoi(pixstring);
				Rect_Erase(9);
				Draw_Text_GDI("Pix number:", 685, 550, RGB(255, 255, 255), lpddsprimary);
				sprintf(buffer, "%d", pixnum);
				Draw_Text_GDI(buffer, 775, 550, RGB(255, 255, 255), lpddsprimary);
				Load_Old_Image(pixnum);
				Rect_Erase(5);
				nextmove = 0;
				break;
			}

			case 2:
			{
			//Save new
				PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
				ShowBitmapFromFile(lpddsprimary, 285, 500, "save_down_button.bmp");
				Save_New_Image(lpddsprimary);
				PlaySound(MAKEINTRESOURCE(SoftSave_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
				Sleep(200);
				mouse_state.rgbButtons[0] = 0;
				nextmove = 0;
				break;
			}
			case 3:
			{
			//Clear
			// clear the drawing surface
				PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
				ShowBitmapFromFile(lpddsprimary, 410, 500, "clear_down_button.bmp");
				Sleep(500);
				DDraw_Fill_Surface(lpddsprimary, 0);
				pixnum = 0;
				done = 0;
				pixnew = 0;
				nextmove = 0;
				keydone = 0;
				a = 0;
				settingsdone = 0;
				pixdone = 0;
				break;
			}
			case 4:
			{
			//Quit
				PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
				ShowBitmapFromFile(lpddsprimary, 535, 500, "quit_down_button.bmp");
				PostMessage(main_window_handle,WM_CLOSE,0,0);
				window_closed = 1;
				break;
			}
			case 5:
			{
			//Settings
				PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
				ShowBitmapFromFile(lpddsprimary, 160, 540, "settings_down_button.bmp");
				ShowBitmapFromFile(lpddsprimary, 420, 440, "Loadsettings.bmp");
				ShowBitmapFromFile(lpddsprimary, 505, 440, "savesettings.bmp");
				ShowBitmapFromFile(lpddsprimary, 590, 440, "Sizesettings.bmp");
				Sleep(100);
				mouse_x = 537;
				mouse_y = 450;
				SetCursorPos(mouse_x, mouse_y);
				ClipCursor(&SettingsRect);
				mouse_state.rgbButtons[0] = 0;
				do
				{
					Sleep(50);					
					if (KEYDOWN(VK_ESCAPE))
					{
						PostMessage(main_window_handle,WM_CLOSE,0,0);
						window_closed = 1;
					}
					// get the input from the mouse
					lpdimouse->lpVtbl->GetDeviceState(lpdimouse, sizeof(DIMOUSESTATE), (LPVOID)&mouse_state);
					// move the mouse cursor
					mouse_x+=(mouse_state.lX); 
					mouse_y+=(mouse_state.lY); 
					SetCursorPos(mouse_x, mouse_y);
					if(mouse_state.rgbButtons[0])
					{
						if((mouse_x>420)&&(mouse_x<484))
						{
							PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
							ShowBitmapFromFile(lpddsprimary, 420, 440, "Loadsettings_down.bmp");
							a = 1; //load file name
							settingsdone = 1;
							Sleep(100);
						}
						if((mouse_x>505)&&(mouse_x<569))
						{
							PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
							ShowBitmapFromFile(lpddsprimary, 505, 440, "Savesettings_down.bmp");
							a = 2; //save file name
							settingsdone = 1;
							Sleep(100);
						}
						if((mouse_x>590)&&(mouse_x<654))
						{
							PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
							ShowBitmapFromFile(lpddsprimary, 590, 440, "Sizesettings_down.bmp");
							a = 3; //size settings
							settingsdone = 1;
							Sleep(100);
						}
					}
				}while(settingsdone == 0);

				ClipCursor(NULL);
				Rect_Erase(1);
				if(a==1)
				{
					Draw_Text_GDI("Change Load File Name:", 420, 410, RGB(255, 0, 0), lpddsprimary);
					Keyreader();
				}
				if(a==2)
				{
					Draw_Text_GDI("Change Save File Name:", 420, 410, RGB(255, 0, 0), lpddsprimary);
					Keyreader();
				}
				if(a==3)
				{
					Draw_Text_GDI("Change Width:", 420, 410, RGB(255, 0, 0), lpddsprimary);
					Rect_Erase(10);
					oldwide = wide;					
					Numbers();
					wide = atoi(numstring);
					sprintf(buffer, "%d", wide);
					Draw_Text_GDI(buffer, 205, 450, RGB(255, 255, 255), lpddsprimary);
					Draw_Text_GDI("Change Height:", 420, 410, RGB(255, 0, 0), lpddsprimary);
					Rect_Erase(11);
					oldhigh = high;
					Numbers();
					high = atoi(numstring);
					sprintf(buffer, "%d", high);
					Draw_Text_GDI(buffer, 311, 450, RGB(255, 255, 255), lpddsprimary);
					a = 0;
					settingsdone = 0;
				}
				if(a==1)
				{
					for(t=0; t<25; t++)
						loadname[t] = filestring[t];
					Rect_Erase(3);
					sprintf(buffer, "%s", loadname);
					Draw_Text_GDI(buffer, 270, 410, RGB(255, 255, 255), lpddsprimary);
					a = 0;
					settingsdone = 0;
				}
				if(a==2)
				{
					for(t=0; t<25; t++)
						savename[t] = filestring[t];
					Rect_Erase(4);
					sprintf(buffer, "%s", savename);
					Draw_Text_GDI(buffer, 270, 430, RGB(255, 255, 255), lpddsprimary);
					a = 0;
					settingsdone = 0;
				}
				Rect_Erase(5);
				nextmove = 0;
				break;
			}
			
			case 6:
			{
				PlaySound(MAKEINTRESOURCE(SoftButton_Sound), hinstance_app, SND_ASYNC | SND_RESOURCE);
				ShowBitmapFromFile(lpddsprimary, 410, 540, "offset_down.bmp");
				Rect_Erase(6);
				Draw_Text_GDI("Change Offset Number:", 420, 410, RGB(255, 0, 0), lpddsprimary);	
				Load_Num();
				offset = atoi(pixstring);
				Rect_Erase(8);
				sprintf(buffer, "%d", offset);
				Draw_Text_GDI(buffer, 220, 470, RGB(255, 255, 255), lpddsprimary);
				Rect_Erase(5);
				nextmove = 0;
				break;
			}

			{
			default:
			nextmove = 0;
			break;
			}
		}

		// test what the user is doing with the mouse
		//this checks button area and is right button down
		if((mouse_x > 684)&&(mouse_y < 432)&&(mouse_state.rgbButtons[1]))
		{
			if((mouse_y>4)&&(mouse_y<16))
				new_color = 0;
			if((mouse_y>20)&&(mouse_y<32))
				new_color = 1;
			if((mouse_y>36)&&(mouse_y<48))
				new_color = 2;
			if((mouse_y>52)&&(mouse_y<64))
				new_color = 3;
			if((mouse_y>68)&&(mouse_y<80))
				new_color = 4;
			if((mouse_y>84)&&(mouse_y<96))
				new_color = 5;
			if((mouse_y>100)&&(mouse_y<112))
				new_color = 6;
			if((mouse_y>116)&&(mouse_y<128))
				new_color = 7;
			if((mouse_y>132)&&(mouse_y<144))
				new_color = 8;
			if((mouse_y>148)&&(mouse_y<160))
				new_color = 9;
			if((mouse_y>164)&&(mouse_y<176))
				new_color = 10;
			if((mouse_y>180)&&(mouse_y<192))
				new_color = 11;
			if((mouse_y>196)&&(mouse_y<208))
				new_color = 12;
			if((mouse_y>212)&&(mouse_y<224))
				new_color = 13;
			if((mouse_y>228)&&(mouse_y<240))
				new_color = 14;
			if((mouse_y>244)&&(mouse_y<256))
				new_color = 15;
			if((mouse_y>260)&&(mouse_y<272))
				new_color = 16;
			if((mouse_y>276)&&(mouse_y<288))
				new_color = 17;
			if((mouse_y>292)&&(mouse_y<304))
				new_color = 18;
			if((mouse_y>308)&&(mouse_y<320))
				new_color = 19;
			if((mouse_y>324)&&(mouse_y<336))
				new_color = 20;
			if((mouse_y>340)&&(mouse_y<352))
				new_color = 21;
			if((mouse_y>356)&&(mouse_y<368))
				new_color = 22;
			if((mouse_y>372)&&(mouse_y<384))
				new_color = 23;
			if((mouse_y>388)&&(mouse_y<400))
				new_color = 24;
			if((mouse_y>404)&&(mouse_y<416))
				new_color = 25;
			if((mouse_y>420)&&(mouse_y<432))
				new_color = 26;

			if((mouse_x>719)&&(mouse_x<741))
				new_color = new_color + 27;
			else if(mouse_x>754)
				new_color = new_color + 54;
			Rect_Erase(7);
			sprintf(buffer,"color %d",new_color);
			Draw_Text_GDI(buffer, 360,SCREEN_HEIGHT - 28,PALETTEINDEX(15),lpddsprimary);
		}

		// display coords
		sprintf(buffer,"Pointer (%d,%d)",mouse_x,mouse_y);
		Draw_Text_GDI(buffer, 12,SCREEN_HEIGHT - 28,PALETTEINDEX(15),lpddsprimary);
	}while(nextmove==0);
	// return success or failure or your own return code here
	return(1);

} // end Game_Main
/////////////////////////////////////////
void WriteSaveName(void)
{
	FILE *stream;

   	/* Open file in text mode: */
   	if( (stream = fopen( "SaveName.dat", "w+t" )) != NULL )
   	{
      		fwrite( savename, sizeof( char ), 25, stream );
      		fclose( stream );
   	}
   	else
	{
      		Draw_Text_GDI( "Problem opening the SaveName file\n", 30, 40, RGB(255, 255, 255), lpddsprimary);
		Sleep(2000);
	}
}
////////////////////////////////////////////
void LoadSaveName(void)
{
	FILE *stream;

	if( (stream = fopen( "SaveName.dat", "r+t" )) != NULL )
   	{
      		/* Attempt to read in 25 characters */
      		fread( savename, sizeof( char ), 25, stream );
      		fclose( stream );
   	}
   	else
	{
		Draw_Text_GDI( "SaveName file could not be opened\n", 30, 40, RGB(255, 255, 255), lpddsprimary);
		Sleep(2000);
	}
}
/////////////////////////////////////////
void WriteLoadName(void)
{
	FILE *stream;

   	/* Open file in text mode: */
   	if( (stream = fopen( "LoadName.dat", "w+t" )) != NULL )
   	{
      		fwrite( loadname, sizeof( char ), 25, stream );
      		fclose( stream );
   	}
   	else
	{
      		Draw_Text_GDI( "Problem opening the LoadName file\n", 30, 40, RGB(255, 255, 255), lpddsprimary);
		Sleep(2000);
	}
}
////////////////////////////////////////////
void LoadLoadName(void)
{
	FILE *stream;

	if( (stream = fopen( "LoadName.dat", "r+t" )) != NULL )
   	{
      		/* Attempt to read in 25 characters */
      		fread( loadname, sizeof( char ), 25, stream );
      		fclose( stream );
   	}
   	else
	{
		Draw_Text_GDI( "LoadName file could not be opened\n", 30, 40, RGB(255, 255, 255), lpddsprimary);
		Sleep(2000);
	}
}
/////////////////////////////////////////
void WriteWideHigh(void)
{
	FILE *fptr;

	if((fptr=fopen("SaveSize.dat", "w+b"))!=NULL)
	{
		putc(wide, fptr);
		putc(high, fptr);
		fclose(fptr);
	}
	else
	{
		Draw_Text_GDI( "SaveSize file could not be opened\n", 30, 40, RGB(255, 255, 255), lpddsprimary);
		Sleep(2000);
	}
}
//////////////////////////////////
void LoadWideHigh(void)
{
	FILE *fptr;

	if((fptr=fopen("SaveSize.dat", "r+b"))!=NULL)
	{
		fseek(fptr, 0, SEEK_SET);
		wide = getc(fptr);
		high = getc(fptr);
		fclose(fptr);
	}
	else
	{
		Draw_Text_GDI( "SaveSize file could not be opened\n", 30, 40, RGB(255, 255, 255), lpddsprimary);
		Sleep(2000);
	}
}
/////////////////////////////////////////
void Load_Num(void)
{
	int i = 0;

	Draw_Text_GDI("Hit Enter When Done", 420, 470, RGB(255, 0, 0), lpddsprimary);
	kup = TRUE;
	memset(&pixstring,0,sizeof(pixstring));
	pixdone = 0;
	Sleep(200);

	do
	{
		// for now test if user is hitting ESC and send WM_CLOSE
		if (KEYDOWN(VK_ESCAPE))
		{
			PostMessage(main_window_handle,WM_CLOSE,0,0);
			window_closed = 1;
		}

		if(kup==TRUE)
		{
			lpdikey->lpVtbl->GetDeviceState(lpdikey, 256, (LPVOID)keystate);
			if(keystate[DIK_1] & 0x80)
			{
				pixstring[i] = '1';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_2] & 0x80)
			{
				pixstring[i] = '2';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_3] & 0x80)
			{
				pixstring[i] = '3';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_4] & 0x80)
			{
				pixstring[i] = '4';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_5] & 0x80)
			{
				pixstring[i] = '5';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_6] & 0x80)
			{
				pixstring[i] = '6';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_7] & 0x80)
			{
				pixstring[i] = '7';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_8] & 0x80)
			{
				pixstring[i] = '8';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_9] & 0x80)
			{
				pixstring[i] = '9';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_0] & 0x80)
			{
				pixstring[i] = '0';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_BACKSPACE] & 0x80)
			{
				pixstring[i-1] = ' ';
				kup = FALSE;
				i = i - 1;
			}
			if(keystate[DIK_RETURN] & 0x80)
			{
				pixdone = 1;
			}
			kup = TRUE;
			Sleep(120);					
		}
		Rect_Erase(2);
		sprintf(buffer, "%s", pixstring);
		Draw_Text_GDI(buffer, 420, 440, RGB(255, 0, 0), lpddsprimary);
	} while(pixdone==0);
	pixdone = 0;
}
////////////////////////////////////////
void Numbers(void)
{
	int i = 0;

	Draw_Text_GDI("Hit Enter When Done", 420, 470, RGB(255, 0, 0), lpddsprimary);
	kup = TRUE;
	memset(&numstring,0,sizeof(numstring));
	keydone = 0;
	Sleep(200);

	do
	{
		// for now test if user is hitting ESC and send WM_CLOSE
		if (KEYDOWN(VK_ESCAPE))
		{
			PostMessage(main_window_handle,WM_CLOSE,0,0);
			window_closed = 1;
		}

		if(kup==TRUE)
		{
			lpdikey->lpVtbl->GetDeviceState(lpdikey, 256, (LPVOID)keystate);
			if(keystate[DIK_1] & 0x80)
			{
				numstring[i] = '1';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_2] & 0x80)
			{
				numstring[i] = '2';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_3] & 0x80)
			{
				numstring[i] = '3';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_4] & 0x80)
			{
				numstring[i] = '4';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_5] & 0x80)
			{
				numstring[i] = '5';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_6] & 0x80)
			{
				numstring[i] = '6';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_7] & 0x80)
			{
				numstring[i] = '7';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_8] & 0x80)
			{
				numstring[i] = '8';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_9] & 0x80)
			{
				numstring[i] = '9';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_0] & 0x80)
			{
				numstring[i] = '0';
				kup = FALSE;
				i++;
			}
			if(keystate[DIK_BACKSPACE] & 0x80)
			{
				numstring[i-1] = ' ';
				kup = FALSE;
				i = i - 1;
			}
			if(keystate[DIK_RETURN] & 0x80)
			{
				keydone = 1;
			}
			kup = TRUE;
			Sleep(120);					
		}
		Rect_Erase(2);
		sprintf(buffer, "%s", numstring);
		Draw_Text_GDI(buffer, 420, 440, RGB(255, 0, 0), lpddsprimary);
		if(i==3)
			keydone = 1;
	} while(keydone==0);
	keydone = 0;
}
/////////////////////////////////////////
void Keyreader(void)
{	
	int i = 0;

	Draw_Text_GDI("Hit Enter When Done", 420, 470, RGB(255, 0, 0), lpddsprimary);
	kup = TRUE;
	memset(&filestring,0,sizeof(filestring));
	keydone = 0;
	Sleep(200);
	do
	{
		// for now test if user is hitting ESC and send WM_CLOSE
		if (KEYDOWN(VK_ESCAPE))
		{
			PostMessage(main_window_handle,WM_CLOSE,0,0);
			window_closed = 1;
		}

		if(kup==TRUE)
		{
			lpdikey->lpVtbl->GetDeviceState(lpdikey, 256, (LPVOID)keystate);
			if((keystate[DIK_LSHIFT]&0x80)||(keystate[DIK_RSHIFT]&0x80))
			{	
				if(keystate[DIK_A] & 0x80)
				{
					filestring[i] = 'A';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_B] & 0x80)
				{
					filestring[i] = 'B';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_C] & 0x80)
				{
					filestring[i] = 'C';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_D] & 0x80)
				{
					filestring[i] = 'D';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_E] & 0x80)
				{
					filestring[i] = 'E';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_F] & 0x80)
				{
					filestring[i] = 'F';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_G] & 0x80)
				{
					filestring[i] = 'G';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_H] & 0x80)
				{
					filestring[i] = 'H';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_I] & 0x80)
				{
					filestring[i] = 'I';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_J] & 0x80)
				{
					filestring[i] = 'J';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_K] & 0x80)
				{
					filestring[i] = 'K';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_L] & 0x80)
				{
					filestring[i] = 'L';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_M] & 0x80)
				{
					filestring[i] = 'M';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_N] & 0x80)
				{
					filestring[i] = 'N';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_O] & 0x80)
				{
					filestring[i] = 'O';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_P] & 0x80)
				{
					filestring[i] = 'P';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_Q] & 0x80)
				{
					filestring[i] = 'Q';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_R] & 0x80)
				{
					filestring[i] = 'R';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_S] & 0x80)
				{
					filestring[i] = 'S';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_T] & 0x80)
				{
					filestring[i] = 'T';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_U] & 0x80)
				{
					filestring[i] = 'U';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_V] & 0x80)
				{
					filestring[i] = 'V';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_W] & 0x80)
				{
					filestring[i] = 'W';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_X] & 0x80)
				{
					filestring[i] = 'X';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_Y] & 0x80)
				{
					filestring[i] = 'Y';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_Z] & 0x80)
				{
					filestring[i] = 'Z';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_MINUS] & 0x80)
				{
					filestring[i] = '_';
					kup = FALSE;
					i++;
				}
			}
			else
			{
				if(keystate[DIK_A] & 0x80)
				{
					filestring[i] = 'a';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_B] & 0x80)
				{
					filestring[i] = 'b';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_C] & 0x80)
				{
					filestring[i] = 'c';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_D] & 0x80)
				{
					filestring[i] = 'd';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_E] & 0x80)
				{
					filestring[i] = 'e';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_F] & 0x80)
				{
					filestring[i] = 'f';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_G] & 0x80)
				{
					filestring[i] = 'g';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_H] & 0x80)
				{
					filestring[i] = 'h';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_I] & 0x80)
				{
					filestring[i] = 'i';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_J] & 0x80)
				{
					filestring[i] = 'j';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_K] & 0x80)
				{
					filestring[i] = 'k';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_L] & 0x80)
				{
					filestring[i] = 'l';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_M] & 0x80)
				{
					filestring[i] = 'm';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_N] & 0x80)
				{
					filestring[i] = 'n';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_O] & 0x80)
				{
					filestring[i] = 'o';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_P] & 0x80)
				{
					filestring[i] = 'p';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_Q] & 0x80)
				{
					filestring[i] = 'q';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_R] & 0x80)
				{
					filestring[i] = 'r';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_S] & 0x80)
				{
					filestring[i] = 's';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_T] & 0x80)
				{
					filestring[i] = 't';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_U] & 0x80)
				{
					filestring[i] = 'u';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_V] & 0x80)
				{
					filestring[i] = 'v';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_W] & 0x80)
				{
					filestring[i] = 'w';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_X] & 0x80)
				{
					filestring[i] = 'x';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_Y] & 0x80)
				{
					filestring[i] = 'y';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_Z] & 0x80)
				{
					filestring[i] = 'z';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_1] & 0x80)
				{
					filestring[i] = '1';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_2] & 0x80)
				{
					filestring[i] = '2';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_3] & 0x80)
				{
					filestring[i] = '3';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_4] & 0x80)
				{
					filestring[i] = '4';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_5] & 0x80)
				{
					filestring[i] = '5';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_6] & 0x80)
				{
					filestring[i] = '6';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_7] & 0x80)
				{
					filestring[i] = '7';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_8] & 0x80)
				{
					filestring[i] = '8';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_9] & 0x80)
				{
					filestring[i] = '9';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_0] & 0x80)
				{
					filestring[i] = '0';
					kup = FALSE;
					i++;
				}
				if(keystate[DIK_BACKSPACE] & 0x80)
				{
					filestring[i-1] = ' ';
					kup = FALSE;
					i = i - 1;
				}
				if(keystate[DIK_RETURN] & 0x80)
				{
					keydone = 1;
				}
			}
				kup = TRUE;
				Sleep(120);					
		}
		Rect_Erase(2);
		sprintf(buffer, "%s", filestring);
		Draw_Text_GDI(buffer, 420, 440, RGB(255, 0, 0), lpddsprimary);
		if(i==20)
			keydone = 1;
	} while(keydone==0);
	strcat(filestring, fileend);
	sprintf(buffer, "%s", filestring);
	Draw_Text_GDI(buffer, 420, 440, RGB(255, 0, 0), lpddsprimary);
	keydone = 0;
}
/////////////////////////////////////////////
void Rect_Erase(int section)
{
	HDC xdc;

	lpddsprimary->lpVtbl->GetDC(lpddsprimary, &xdc);
	HPEN black_pen = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	HPEN oldpen;	
	HBRUSH black_brush = CreateSolidBrush(RGB(0, 0, 0));
	HBRUSH oldbrush;
	SetBkColor(xdc, RGB(0, 0, 0));
	oldpen = (HPEN)SelectObject(xdc, black_pen);
	oldbrush = (HBRUSH)SelectObject(xdc, black_brush);
	if(section == 1)  //Erase the settings change buttons
		Rectangle(xdc, 420, 410, 655, 465);
	if(section == 2)  //Erase the file name
		Rectangle(xdc, 410, 435, 670, 460);
	if(section == 3)  //Erase the load file name at left
		Rectangle(xdc, 265, 406, 412, 427);
	if(section == 4)  //Erase the save file name at left
		Rectangle(xdc, 265, 428, 412, 449);
	if(section == 5)  //Erase settings info on right
		Rectangle(xdc, 390, 405, 665, 495);  //new
	if(section == 6)  //Erase pixnum and number info on lower right
		Rectangle(xdc, 521, 440, 605, 470);
	if(section == 7)  //Erase color number at bottom
		Rectangle(xdc, 200, 460, 270, 479);
	if(section == 8)  //Erase the offset number at left
		Rectangle(xdc, 202, 467, 260, 488);
	if(section == 9)  //Erase the pix number, lower right
		Rectangle(xdc, 775, 550, 795, 580);
	if(section == 10)  //Erase the width, left
		Rectangle(xdc, 197, 448, 238, 468);
	if(section == 11)  //Erase the height, left
		Rectangle(xdc, 298, 448, 340, 468);
	SelectObject(xdc, oldpen);
	SelectObject(xdc, oldbrush);
	DeleteObject(black_pen);
	DeleteObject(black_brush);
	lpddsprimary->lpVtbl->ReleaseDC(lpddsprimary,xdc);
}

/////DirectDraw Version
int ShowBitmapFromFile(LPDIRECTDRAWSURFACE7 lpdds, int xDest, int yDest, LPCSTR szBitmap)
{
	HDC hSrcDC;				//source DC - memory device context
	HDC hDestDC;				//destination DC - surface device context
	HBITMAP hBitmap;		//handle to the bitmap resource
	BITMAP bmp;				//structure for bitmap info
	int nHeight, nWidth;	//bitmap dimensions

	//Load the bitmap
	if ((hBitmap = (HBITMAP)LoadImage(NULL, szBitmap, IMAGE_BITMAP,
		0, 0, LR_CREATEDIBSECTION | LR_LOADFROMFILE)) == NULL)
		return(FALSE);

	//create a DC for the bitmap to use
	if ((hSrcDC = CreateCompatibleDC(NULL)) == NULL)
		return(FALSE);

	//select the bitmap into the DC
	if (SelectObject(hSrcDC, hBitmap) == NULL)
	{
		DeleteDC(hSrcDC);
		return(FALSE);
	}

	//get image dimensions
	if(GetObject(hBitmap, sizeof(BITMAP), &bmp) == 0)
	{
		DeleteDC(hSrcDC);
		return(FALSE);
	}

	nWidth = bmp.bmWidth;
	nHeight = bmp.bmHeight;

	//retrieve surface DC
	if(FAILED(lpdds->lpVtbl->GetDC(lpdds, &hDestDC)))
	{
		DeleteDC(hSrcDC);
		return(FALSE);
	}

	//copy image from one DC to the other
	if (BitBlt(hDestDC, xDest, yDest, nWidth, nHeight, hSrcDC, 0, 0,
		SRCCOPY) == FALSE)
	{
		lpdds->lpVtbl->ReleaseDC(lpdds, hDestDC);
		DeleteDC(hSrcDC);
		return(FALSE);
	}

	//Kill the memory DC
	lpdds->lpVtbl->ReleaseDC(lpdds, hDestDC);
	DeleteDC(hSrcDC);
	DeleteObject(hBitmap);

	//return success!
	return(TRUE);
}
//////////////////////////////////////////////////////////////////////////////
void Plot8(int x, int y, UCHAR color, UCHAR *buffer, int mempitch)
{
	buffer[x + y*mempitch] = color;
}
/////////////////////////////////////////////////
int Load_Old_Image(int pixnum)
{	
	FILE *fptr;
	int pixx, pixy;
	int x, y;
	UCHAR pixc;
	long pixoffset;
	long size = wide * high; //5084 for portraits 936 for old WarLandscapes2		
//1344 for new WarTiles  576 for wp.pix 180 for w.pix 299 for Newkwflag.pix - 23 by 13
	//Lock the primary buffer
	if (FAILED(lpddsprimary->lpVtbl->Lock(lpddsprimary, NULL, &ddsd,
                   DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT,
                   NULL)))
		return(0);


	if((fptr=fopen(loadname,"a+b"))==NULL) /*Load image*/
		return(0);

	
	pixoffset = (pixnum) * size;
	fseek(fptr, pixoffset, SEEK_SET);
	
	for(pixy=6; pixy<(6+high); pixy++) //4 & <66 for portraits
	{
		for(pixx=6; pixx<(6+wide); pixx++) //4 & 86 for portraits
		{ 
			pixc = getc(fptr);
			// plot the pixel
			Plot8(pixx, pixy, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
		}
	}
    fclose(fptr);

	//this section copies the image into the drawing grid
	if((fptr=fopen(loadname,"a+b"))==NULL) 
		return(0);

	x = 141;
	y = 6;
	pixoffset = (pixnum) * size;
	fseek(fptr, pixoffset, SEEK_SET);
	for(int s=0; s<high; s++)  //62 for ports - borders = 32
	{
		for(int t=0; t<wide; t++) //82 for ports - borders = 42
		{
			pixc = getc(fptr);
			Plot8(x, y, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+1, y, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+2, y, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+3, y, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x, y+1, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+1, y+1, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+2, y+1, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+3, y+1, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x, y+2, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+1, y+2, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+2, y+2, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+3, y+2, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x, y+3, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+1, y+3, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+2, y+3, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Plot8(x+3, y+3, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			x=x+5;
		}
		x = 141;
		y=y+5;
	}
    fclose(fptr);


	// now unlock the primarybuffer surface
	if (FAILED(lpddsprimary->lpVtbl->Unlock(lpddsprimary, NULL)))
		return(0);
	Load_New_Image(pixnum);
	return(1);
}
//////////////////

int Load_New_Image(int pixnew)
{	
	FILE *fptr;
	int pixx, pixy;
	UCHAR pixc;
	long pixoffset;
	long size = wide*high;  //5084 for portraits 936 for WarLandscapes2	

	//Lock the primary buffer
	if (FAILED(lpddsprimary->lpVtbl->Lock(lpddsprimary, NULL, &ddsd,
                   DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT,
                   NULL)))
		return(0);

	if((fptr=fopen(loadname,"a+b"))==NULL) /*Load image*/
		return(0);

	
	pixoffset = (pixnew) * size;
	fseek(fptr, pixoffset, SEEK_SET);
	for(pixy=128; pixy<(128+high); pixy++)  //136 for borders - 166 for ports
	{
		for(pixx=6; pixx<(6+wide); pixx++)  //46 for borders - 86 for ports
		{ 
			pixc = getc(fptr);
			// plot the pixel
			Plot8(pixx, pixy, pixc, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
		}
	}
    fclose(fptr);

	// now unlock the backbuffer surface
	if (FAILED(lpddsprimary->lpVtbl->Unlock(lpddsprimary, NULL)))
		return(0);

	return(1);
}

//////////////////
int Save_New_Image(LPDIRECTDRAWSURFACE7 lpdds)
{
	FILE *fptr;
	int pixx, pixy;
	HDC xdc;
	COLORREF mycolor = 0;
	COLORREF palcolor = 0;
	int id = 0;
	long pixoffset = 0;

	if (FAILED(lpdds->lpVtbl->GetDC(lpdds, &xdc)))
		return(0);

	if(offset>0)
	{
		pixoffset = (wide * high) * offset;	
		if((fptr=fopen(savename,"r+b"))==NULL) /*Save image*/
		return(0);
		fseek(fptr, pixoffset, SEEK_SET);
	}
	if(offset==0)
		if((fptr=fopen(savename,"a+b"))==NULL) /*Save image*/
		return(0);
	for(pixy=128; pixy<(128+high); pixy++) //was 166
	{
		for(pixx=6; pixx<(6+wide); pixx++) //was 86
		{
			mycolor = GetPixel(xdc, pixx, pixy);
			for(int col = 0; col<3; col++)  
			{
				for(int count = 0; count<27; count++)
				{
					palcolor = GetPixel(xdc, 695+(col*35), 10+(count*16));
					if(mycolor==palcolor)
					id = (col*27)+count;
				}
			}
			putc(id, fptr);
		}
	}
	fclose(fptr);

	lpdds->lpVtbl->ReleaseDC(lpdds, xdc);
	offset = 0;
	return(1);
}
//////////////////////
int Draw_Text_GDI(char *text, int x, int y, COLORREF color, LPDIRECTDRAWSURFACE7 lpdds)
{
	HDC xdc;  //a dc for the direct draw surface
 
	if (FAILED(lpdds->lpVtbl->GetDC(lpdds, &xdc)))
		return(0);
	SetTextColor(xdc, color);
	SetBkColor(xdc, RGB(0, 0, 0));
	SetBkMode(xdc, OPAQUE);
	TextOut(xdc, x, y, text, strlen(text));
	lpdds->lpVtbl->ReleaseDC(lpdds, xdc);
	return(1);
}
//////////////////
//this draws the white square on the left
int Screen_lines_old(LPDIRECTDRAWSURFACE7 lpdds)
{
	HDC xdc;

	if (FAILED(lpdds->lpVtbl->GetDC(lpdds, &xdc)))
		return(0);

	POINT upper_left[10] = {5, 5, 108, 5, 108, 84, 5, 84, 5, 5};

	HPEN white_pen = CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
	HPEN oldpen;	

	SetBkColor(xdc, RGB(0, 0, 0));
	oldpen = (HPEN)SelectObject(xdc, white_pen);

	Polyline(xdc, upper_left, 5);
	SelectObject(xdc, oldpen);
	DeleteObject(white_pen);
	lpdds->lpVtbl->ReleaseDC(lpdds, xdc);
	return(1);

}
/////////////////////
//this draws the second white square on the left
int Screen_lines_new(LPDIRECTDRAWSURFACE7 lpdds)
{
	HDC xdc;

	if (FAILED(lpdds->lpVtbl->GetDC(lpdds, &xdc)))
		return(0);

	POINT upper_left[10] = {5, 127, 108, 127, 108, 206, 5, 206, 5, 127};
	HPEN white_pen = CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
	HPEN oldpen;	

	SetBkColor(xdc, RGB(0, 0, 0));
	oldpen = (HPEN)SelectObject(xdc, white_pen);

	Polyline(xdc, upper_left, 5);
	SelectObject(xdc, oldpen);
	DeleteObject(white_pen);
	lpdds->lpVtbl->ReleaseDC(lpdds, xdc);
	return(1);

}
//////////////////
int Screen_grid(LPDIRECTDRAWSURFACE7 lpdds)
{
	int x1, y1, count, x2, y2;
	POINT outer_old[10] = {140, 5, 650, 5, 650, 395, 140, 395, 140, 5}; 
	HDC xdc;


	if (FAILED(lpdds->lpVtbl->GetDC(lpdds, &xdc)))
		return(0);

	HPEN white_pen = CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
	HPEN oldpen;	
	SetBkColor(xdc, RGB(0, 0, 0));
	oldpen = (HPEN)SelectObject(xdc, white_pen);

	Polyline(xdc, outer_old, 5);

	x1 = 140;
	y1 = 5;
	for (count = 0; count <=78; count++)
	{
		MoveToEx(xdc, x1, y1, NULL);
		LineTo(xdc, x1+510, y1); 
		y1 += 5;
	}
	x1 = 140;
	y1 = 5;
	for (count = 0; count<=102; count++)
	{
		MoveToEx(xdc, x1, y1, NULL);
		LineTo(xdc, x1, y1+390); 
		x1 += 5;
	}
	x1 = ((650-140)/2)+140; 
	y1 = 3;
	SetPixel(xdc, x1, y1, RGB(204, 204, 204)); //Lt Grey
	x1 = 138;
	y1 = 200;
	SetPixel(xdc, x1, y1, RGB(204, 204, 204)); //Lt Grey

	SelectObject(xdc, oldpen);
	DeleteObject(white_pen);
	if(oldwide==51)
	{
		x2 = 140 + (oldwide*5);
		SetPixel(xdc, x2, 2, RGB(0, 0, 0));
	}
	else
	{
		if(oldwide<102)
		{
			x2 = 140 + (oldwide*5);
			SetPixel(xdc, x2, 2, RGB(0, 0, 0));
			SetPixel(xdc, x2, 3, RGB(0, 0, 0));
		}
	}
	if(oldhigh==39)
	{
		y2 = 5 + (oldhigh*5);
 		SetPixel(xdc, 137, y2, RGB(0, 0, 0));
	}
	else
	{
		if(oldhigh<79)
		{
			y2 = 5 + (oldhigh*5);
			SetPixel(xdc, 137, y2, RGB(0, 0, 0));
			SetPixel(xdc, 138, y2, RGB(0, 0, 0));
		}
	}
	if(wide<102)
	{
		x2 = 140 + (wide*5);
		SetPixel(xdc, x2, 2, RGB(255, 0, 0));
		SetPixel(xdc, x2, 3, RGB(255, 0, 0));
	}
	if(high<78)
	{
		y2 = 5 + (high*5);
		SetPixel(xdc, 137, y2, RGB(255, 0, 0));
		SetPixel(xdc, 138, y2, RGB(255, 0, 0));
	}
	lpdds->lpVtbl->ReleaseDC(lpdds, xdc);
	return(1);
}
/////////////////
int DDraw_Fill_Surface(LPDIRECTDRAWSURFACE7 lpdds,int color)
{
	DDBLTFX ddbltfx; // this contains the DDBLTFX structure

	// clear out the structure and set the size field 
	DDRAW_INIT_STRUCT(ddbltfx);

	// set the dwfillcolor field to the desired color
	ddbltfx.dwFillColor = color; 

	// ready to blt to surface
	lpdds->lpVtbl->Blt(lpdds, NULL,       // ptr to dest rectangle
           NULL,       // ptr to source surface, NA            
           NULL,       // ptr to source rectangle, NA
           DDBLT_COLORFILL | DDBLT_WAIT,   // fill and wait                   
           &ddbltfx);  // ptr to DDBLTFX structure

	// return success
	return(0);
} // end DDraw_Fill_Surface
//////////////////////////////

int Build_colors(void)
{
	HDC xdc;
	POINT black_sq[10] = {684, 4, 706, 4, 706, 16, 684, 16, 684, 4};
	int r;
	int x1 = 685;
	int y1 = 5;
	int x2 = 705;
	int y2 = 15;
	int c = 0;

		//Lock the surface
	if (FAILED(lpddsprimary->lpVtbl->Lock(lpddsprimary, NULL, &ddsd,
                   DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT,
                   NULL)))
		return(0);
	
	for(int q = 0; q<27; q++)
	{
		for(int indexx = x1; indexx < x2; indexx++)
		{
			for(int indexy = y1; indexy < y2; indexy++)
			{
				Plot8(indexx, indexy, c, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
			}
		}
		y1 = y1 + 16;
		y2 = y2 + 16;
		c = c + 1;
	}

	x1 = 720;
	y1 = 5;
	x2 = 740;
	y2 = 15;
	c = 27;
	for(int r = 27; r<54; r++)
	{
		for(int indexx = x1; indexx < x2; indexx++)
		{
			for(int indexy = y1; indexy < y2; indexy++)
			{
				Plot8(indexx, indexy, c, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
			}
		}
		y1 = y1 + 16;
		y2 = y2 + 16;
		c = c + 1;
	}
	x1 = 755;
	y1 = 5;
	x2 = 775;
	y2 = 15;
	c = 54;
	for(r = 54; r<80; r++)
	{
		for(int indexx = x1; indexx < x2; indexx++)
		{
			for(int indexy = y1; indexy < y2; indexy++)
			{
				Plot8(indexx, indexy, c, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
			}
		}
		y1 = y1 + 16;
		y2 = y2 + 16;
		c = c + 1;
	}
	x1 = 755;
	x2 = 775;
	c = 80;
	
	for(int indexx = x1; indexx < x2; indexx++)
	{
		for(int indexy = y1; indexy < y2; indexy++)
		{
			Plot8(indexx, indexy, c, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
		}
	}
	
	// now unlock the surface
	if (FAILED(lpddsprimary->lpVtbl->Unlock(lpddsprimary, NULL)))
		return(0);
	if (FAILED(lpddsprimary->lpVtbl->GetDC(lpddsprimary, &xdc)))
		return(0);

	HPEN white_pen = CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
	HPEN oldpen;	
	SetBkColor(xdc, RGB(0, 0, 0));
	oldpen = (HPEN)SelectObject(xdc, white_pen);
	Polyline(xdc, black_sq, 5);
	SelectObject(xdc, oldpen);
	DeleteObject(white_pen);
	lpddsprimary->lpVtbl->ReleaseDC(lpddsprimary, xdc);
	return(0);
}
//////////////////
int Draw_Pix(int new_color) //draws new picture
{
	int zcol, zrow, lx1, ly1;
	int startrow = 5;
	int startcol = 140;
	int count1, count2;
	
		//Lock the surface
	if (FAILED(lpddsprimary->lpVtbl->Lock(lpddsprimary, NULL, &ddsd,
                   DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT,
                   NULL)))
		return(0);
	zcol = (mouse_x - startcol) / 5;
	zrow = ((mouse_y -1) - startrow) / 5;
	lx1 = (startcol + (5 * zcol));
	ly1 = (5 + (5 * zrow));


	for(count1=0; count1<5; count1++)
	{
		for(count2=0; count2<5; count2++)
		{ 
			// plot the pixel
			Plot8(lx1+count1, ly1+count2, new_color, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
		}
	}

	Plot8(6+zcol, 128+zrow, new_color, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        	
	// now unlock surface
	if (FAILED(lpddsprimary->lpVtbl->Unlock(lpddsprimary, NULL)))
		return(0);

	return(0);
}
///////////////////////////
int Draw_Quad(int new_color)  //draw for boxes at a time
{
	int zcol, zrow, lx1, ly1;
	int startrow = 5;
	int startcol = 140;
	int count1, count2;
	
		//Lock the surface
	if (FAILED(lpddsprimary->lpVtbl->Lock(lpddsprimary, NULL, &ddsd,
                   DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT,
                   NULL)))
		return(0);
////first square
	zcol = (mouse_x - startcol) / 5;
	zrow = ((mouse_y -1) - startrow) / 5;
	lx1 = (startcol + (5 * zcol));
	ly1 = (5 + (5 * zrow));


	for(count1=0; count1<5; count1++)
	{
		for(count2=0; count2<5; count2++)
		{ 
			// plot the pixel
			Plot8(lx1+count1, ly1+count2, new_color, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
		}
	}

	Plot8(6+zcol, 128+zrow, new_color, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        	

////second square right of first
	zcol = zcol + 1;
	lx1 = (startcol + (5 * zcol));
	ly1 = (5 + (5 * zrow));
	
	for(count1=0; count1<5; count1++)
	{
		for(count2=0; count2<5; count2++)
		{ 
			// plot the pixel
			Plot8(lx1+count1, ly1+count2, new_color, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
		}
	}

	Plot8(6+zcol, 128+zrow, new_color, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        	

////third square below first
	zcol = zcol - 1;
	zrow = zrow + 1;
	lx1 = (startcol + (5 * zcol));
	ly1 = (5 + (5 * zrow));
	
	for(count1=0; count1<5; count1++)
	{
		for(count2=0; count2<5; count2++)
		{ 
			// plot the pixel
			Plot8(lx1+count1, ly1+count2, new_color, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
		}
	}

	Plot8(6+zcol, 128+zrow, new_color, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        	

/////fourth square below & right of first
	zcol = zcol + 1;
	lx1 = (startcol + (5 * zcol));
	ly1 = (5 + (5 * zrow));
	
	for(count1=0; count1<5; count1++)
	{
		for(count2=0; count2<5; count2++)
		{ 
			// plot the pixel
			Plot8(lx1+count1, ly1+count2, new_color, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        
		}
	}

	Plot8(6+zcol, 128+zrow, new_color, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);        	
//////
	// now unlock the surface
	if (FAILED(lpddsprimary->lpVtbl->Unlock(lpddsprimary, NULL)))
		return(0);

	return(0);

}
///////////////////////////////////////////////////////////

int Game_Init(void)
{
	// this is called once after the initial window is created and
	// before the main event loop is entered, do all your initialization
	// here

//added & before IID_IDirectDraw7
	if (FAILED(DirectDrawCreateEx(NULL, (LPVOID *)&lpdd7, &IID_IDirectDraw7, NULL)))
		return(0); //error
	


	if (FAILED(lpdd7->lpVtbl->SetCooperativeLevel(lpdd7, main_window_handle, 
								DDSCL_FULLSCREEN | DDSCL_ALLOWMODEX |
								DDSCL_EXCLUSIVE | DDSCL_ALLOWREBOOT)))
		return(0); //error

	// set display mode to 800x600x8
	if (FAILED(lpdd7->lpVtbl->SetDisplayMode(lpdd7, SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,0,0)))
		return(0);


	// clear ddsd and set size
	memset(&ddsd,0,sizeof(ddsd)); 
	ddsd.dwSize = sizeof(ddsd);

	// enable valid fields	
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;

	ddsd.dwBackBufferCount = 1;

	// request primary surface with one backbuffer
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP |
                             DDSCAPS_COMPLEX;
    

	// create the primary surface
	if (FAILED(lpdd7->lpVtbl->CreateSurface(lpdd7, &ddsd, &lpddsprimary, NULL)))
		return(0);

	// Attach lpddsback to the backbuffer
      ddsd.ddsCaps.dwCaps = DDSCAPS_BACKBUFFER;
	if (FAILED(lpddsprimary->lpVtbl->GetAttachedSurface(lpddsprimary, &ddsd.ddsCaps, &lpddsback)))
		return(0);

	// build up the palette data array
	for (int color=1; color < 255; color++)
		{
		// fill with random RGB values
		palette[color].peRed   = rand()%256;
		palette[color].peGreen = rand()%256;
		palette[color].peBlue  = rand()%256;

		// set flags field to PC_NOCOLLAPSE
		palette[color].peFlags = PC_NOCOLLAPSE;
		} // end for color


	//add my palette colors
	palette[1].peRed   = 0;
	palette[1].peGreen = 0;
	palette[1].peBlue  = 204;	
	palette[1].peFlags = PC_NOCOLLAPSE;

	palette[2].peRed   = 51;
	palette[2].peGreen = 153;
	palette[2].peBlue  = 51;
	palette[2].peFlags = PC_NOCOLLAPSE;

	palette[3].peRed   = 0;
	palette[3].peGreen = 255;
	palette[3].peBlue  = 255;
	palette[3].peFlags = PC_NOCOLLAPSE;

	palette[4].peRed   = 255;
	palette[4].peGreen = 0;
	palette[4].peBlue  = 0;
	palette[4].peFlags = PC_NOCOLLAPSE;

	palette[5].peRed   = 153;
	palette[5].peGreen = 0;
	palette[5].peBlue  = 204;
	palette[5].peFlags = PC_NOCOLLAPSE;

	palette[6].peRed   = 153;
	palette[6].peGreen = 51;
	palette[6].peBlue  = 0;
	palette[6].peFlags = PC_NOCOLLAPSE;

	palette[7].peRed   = 204;
	palette[7].peGreen = 204;
	palette[7].peBlue  = 204;
	palette[7].peFlags = PC_NOCOLLAPSE;

	palette[8].peRed   = 153;
	palette[8].peGreen = 153;
	palette[8].peBlue  = 153;
	palette[8].peFlags = PC_NOCOLLAPSE;

	palette[9].peRed   = 255;
	palette[9].peGreen = 204;
	palette[9].peBlue  = 102;
	palette[9].peFlags = PC_NOCOLLAPSE;

	palette[10].peRed   = 255;
	palette[10].peGreen = 217;
	palette[10].peBlue  = 217;
	palette[10].peFlags = PC_NOCOLLAPSE;

	palette[11].peRed   = 251;
	palette[11].peGreen = 191;
	palette[11].peBlue  = 191;
	palette[11].peFlags = PC_NOCOLLAPSE;

	palette[12].peRed   = 254;
	palette[12].peGreen = 92;
	palette[12].peBlue  = 92;
	palette[12].peFlags = PC_NOCOLLAPSE;

	palette[13].peRed   = 254;
	palette[13].peGreen = 198;
	palette[13].peBlue  = 198;
	palette[13].peFlags = PC_NOCOLLAPSE;

	palette[14].peRed   = 255;
	palette[14].peGreen = 255;
	palette[14].peBlue  = 64;
	palette[14].peFlags = PC_NOCOLLAPSE;

	palette[15].peRed   = 255;
	palette[15].peGreen = 255;
	palette[15].peBlue  = 255;
	palette[15].peFlags = PC_NOCOLLAPSE;

	palette[16].peRed   = 244;
	palette[16].peGreen = 198;
	palette[16].peBlue  = 126;
	palette[16].peFlags = PC_NOCOLLAPSE;
	
	palette[17].peRed   = 216;
	palette[17].peGreen = 212;
	palette[17].peBlue  = 212;
	palette[17].peFlags = PC_NOCOLLAPSE;

	palette[18].peRed   = 0;
	palette[18].peGreen = 255;
	palette[18].peBlue  = 0;
	palette[18].peFlags = PC_NOCOLLAPSE;

	palette[19].peRed   = 255;
	palette[19].peGreen = 64;
	palette[19].peBlue  = 64;
	palette[19].peFlags = PC_NOCOLLAPSE;

	palette[20].peRed   = 128;
	palette[20].peGreen = 128;
	palette[20].peBlue  = 255;
	palette[20].peFlags = PC_NOCOLLAPSE;

	palette[21].peRed   = 64;
	palette[21].peGreen = 64;
	palette[21].peBlue  = 255;
	palette[21].peFlags = PC_NOCOLLAPSE;
	
	palette[22].peRed   = 0;
	palette[22].peGreen = 192;
	palette[22].peBlue  = 0;
	palette[22].peFlags = PC_NOCOLLAPSE;

	palette[23].peRed   = 150;
	palette[23].peGreen = 100;
	palette[23].peBlue  = 14;
	palette[23].peFlags = PC_NOCOLLAPSE;

	palette[24].peRed   = 151;
	palette[24].peGreen = 131;
	palette[24].peBlue  = 71;
	palette[24].peFlags = PC_NOCOLLAPSE;

	palette[25].peRed   = 144;
	palette[25].peGreen = 99;
	palette[25].peBlue  = 34;
	palette[25].peFlags = PC_NOCOLLAPSE;

	palette[26].peRed   = 172;
	palette[26].peGreen = 102;
	palette[26].peBlue  = 102;
	palette[26].peFlags = PC_NOCOLLAPSE;

	palette[27].peRed   = 212;
	palette[27].peGreen = 214;
	palette[27].peBlue  = 12;
	palette[27].peFlags = PC_NOCOLLAPSE;

	palette[28].peRed   = 253;
	palette[28].peGreen = 254;
	palette[28].peBlue  = 160;
	palette[28].peFlags = PC_NOCOLLAPSE;

	palette[29].peRed   = 249;
	palette[29].peGreen = 226;
	palette[29].peBlue  = 31;
	palette[29].peFlags = PC_NOCOLLAPSE;

	palette[30].peRed   = 149;
	palette[30].peGreen = 127;
	palette[30].peBlue  = 49;
	palette[30].peFlags = PC_NOCOLLAPSE;

	palette[31].peRed   = 213;
	palette[31].peGreen = 161;
	palette[31].peBlue  = 3;
	palette[31].peFlags = PC_NOCOLLAPSE;
	
	palette[32].peRed   = 0;
	palette[32].peGreen = 192;
	palette[32].peBlue  = 192;
	palette[32].peFlags = PC_NOCOLLAPSE;

	palette[33].peRed   = 63;
	palette[33].peGreen = 255;
	palette[33].peBlue  = 253;
	palette[33].peFlags = PC_NOCOLLAPSE;

	palette[34].peRed   = 187;
	palette[34].peGreen = 251;
	palette[34].peBlue  = 250;
	palette[34].peFlags = PC_NOCOLLAPSE;

	palette[35].peRed   = 6;
	palette[35].peGreen = 110;
	palette[35].peBlue  = 109;
	palette[35].peFlags = PC_NOCOLLAPSE;

	palette[36].peRed   = 231;
	palette[36].peGreen = 177;
	palette[36].peBlue  = 177;
	palette[36].peFlags = PC_NOCOLLAPSE;

	palette[37].peRed   = 222;
	palette[37].peGreen = 186;
	palette[37].peBlue  = 186;
	palette[37].peFlags = PC_NOCOLLAPSE;

	palette[38].peRed   = 165;
	palette[38].peGreen = 163;
	palette[38].peBlue  = 163;
	palette[38].peFlags = PC_NOCOLLAPSE;

	palette[39].peRed   = 231;
	palette[39].peGreen = 227;
	palette[39].peBlue  = 227;
	palette[39].peFlags = PC_NOCOLLAPSE;

	palette[40].peRed   = 105;
	palette[40].peGreen = 101;
	palette[40].peBlue  = 101;
	palette[40].peFlags = PC_NOCOLLAPSE;

	palette[41].peRed   = 208;
	palette[41].peGreen = 5;
	palette[41].peBlue  = 221;
	palette[41].peFlags = PC_NOCOLLAPSE;
	
	palette[42].peRed   = 170;
	palette[42].peGreen = 7;
	palette[42].peBlue  = 185;
	palette[42].peFlags = PC_NOCOLLAPSE;

	palette[43].peRed   = 220;
	palette[43].peGreen = 156;
	palette[43].peBlue  = 234;
	palette[43].peFlags = PC_NOCOLLAPSE;

	palette[44].peRed   = 0;
	palette[44].peGreen = 0;
	palette[44].peBlue  = 64;
	palette[44].peFlags = PC_NOCOLLAPSE;

	palette[45].peRed   = 2;
	palette[45].peGreen = 5;
	palette[45].peBlue  = 114;
	palette[45].peFlags = PC_NOCOLLAPSE;

	palette[46].peRed   = 2;
	palette[46].peGreen = 6;
	palette[46].peBlue  = 166;
	palette[46].peFlags = PC_NOCOLLAPSE;

	palette[47].peRed   = 94;
	palette[47].peGreen = 1;
	palette[47].peBlue  = 95;
	palette[47].peFlags = PC_NOCOLLAPSE;

	palette[48].peRed   = 128;
	palette[48].peGreen = 0;
	palette[48].peBlue  = 128;
	palette[48].peFlags = PC_NOCOLLAPSE;

	palette[49].peRed   = 0;
	palette[49].peGreen = 64;
	palette[49].peBlue  = 64;
	palette[49].peFlags = PC_NOCOLLAPSE;

	palette[50].peRed   = 11;
	palette[50].peGreen = 115;
	palette[50].peBlue  = 114;
	palette[50].peFlags = PC_NOCOLLAPSE;

	palette[51].peRed   = 39;
	palette[51].peGreen = 143;
	palette[51].peBlue  = 142;
	palette[51].peFlags = PC_NOCOLLAPSE;
	
	palette[52].peRed   = 0;
	palette[52].peGreen = 64;
	palette[52].peBlue  = 0;
	palette[52].peFlags = PC_NOCOLLAPSE;

	palette[53].peRed   = 7;
	palette[53].peGreen = 137;
	palette[53].peBlue  = 7;
	palette[53].peFlags = PC_NOCOLLAPSE;

	palette[54].peRed   = 146;
	palette[54].peGreen = 147;
	palette[54].peBlue  = 45;
	palette[54].peFlags = PC_NOCOLLAPSE;

	palette[55].peRed   = 155;
	palette[55].peGreen = 156;
	palette[55].peBlue  = 90;
	palette[55].peFlags = PC_NOCOLLAPSE;

	palette[56].peRed   = 148;
	palette[56].peGreen = 26;
	palette[56].peBlue  = 26;
	palette[56].peFlags = PC_NOCOLLAPSE;

	palette[57].peRed   = 118;
	palette[57].peGreen = 2;
	palette[57].peBlue  = 2;
	palette[57].peFlags = PC_NOCOLLAPSE;

	palette[58].peRed   = 174;
	palette[58].peGreen = 4;
	palette[58].peBlue  = 4;
	palette[58].peFlags = PC_NOCOLLAPSE;

	palette[59].peRed   = 168;
	palette[59].peGreen = 72;
	palette[59].peBlue  = 72;
	palette[59].peFlags = PC_NOCOLLAPSE;

	palette[60].peRed   = 148;
	palette[60].peGreen = 102;
	palette[60].peBlue  = 102;
	palette[60].peFlags = PC_NOCOLLAPSE;

	palette[61].peRed   = 190;
	palette[61].peGreen = 162;
	palette[61].peBlue  = 162;
	palette[61].peFlags = PC_NOCOLLAPSE;
	
	palette[62].peRed   = 233;
	palette[62].peGreen = 113;
	palette[62].peBlue  = 7;
	palette[62].peFlags = PC_NOCOLLAPSE;

	palette[63].peRed   = 254;
	palette[63].peGreen = 154;
	palette[63].peBlue  = 74;
	palette[63].peFlags = PC_NOCOLLAPSE;

	palette[64].peRed   = 168;
	palette[64].peGreen = 113;
	palette[64].peBlue  = 48;
	palette[64].peFlags = PC_NOCOLLAPSE;

	palette[65].peRed   = 197;
	palette[65].peGreen = 115;
	palette[65].peBlue  = 43;
	palette[65].peFlags = PC_NOCOLLAPSE;

	palette[66].peRed   = 189;
	palette[66].peGreen = 154;
	palette[66].peBlue  = 109;
	palette[66].peFlags = PC_NOCOLLAPSE;

	palette[67].peRed   = 186;
	palette[67].peGreen = 170;
	palette[67].peBlue  = 126;
	palette[67].peFlags = PC_NOCOLLAPSE;

	palette[68].peRed   = 243;
	palette[68].peGreen = 218;
	palette[68].peBlue  = 171;
	palette[68].peFlags = PC_NOCOLLAPSE;

	palette[69].peRed   = 253;
	palette[69].peGreen = 206;
	palette[69].peBlue  = 131;
	palette[69].peFlags = PC_NOCOLLAPSE;

	palette[70].peRed   = 255;
	palette[70].peGreen = 255;
	palette[70].peBlue  = 192;
	palette[70].peFlags = PC_NOCOLLAPSE;

	palette[71].peRed   = 255;
	palette[71].peGreen = 255;
	palette[71].peBlue  = 128;
	palette[71].peFlags = PC_NOCOLLAPSE;
	
	palette[72].peRed   = 192;
	palette[72].peGreen = 192;
	palette[72].peBlue  = 255;
	palette[72].peFlags = PC_NOCOLLAPSE;

	palette[73].peRed   = 255;
	palette[73].peGreen = 208;
	palette[73].peBlue  = 208;
	palette[73].peFlags = PC_NOCOLLAPSE;

	palette[74].peRed   = 109;
	palette[74].peGreen = 112;
	palette[74].peBlue  = 227;
	palette[74].peFlags = PC_NOCOLLAPSE;

	palette[75].peRed   = 56;
	palette[75].peGreen = 118;
	palette[75].peBlue  = 111;
	palette[75].peFlags = PC_NOCOLLAPSE;

	palette[76].peRed   = 149;
	palette[76].peGreen = 92;
	palette[76].peBlue  = 25;
	palette[76].peFlags = PC_NOCOLLAPSE;

	palette[77].peRed   = 253;
	palette[77].peGreen = 196;
	palette[77].peBlue  = 41;
	palette[77].peFlags = PC_NOCOLLAPSE;

	palette[78].peRed   = 253;
	palette[78].peGreen = 216;
	palette[78].peBlue  = 89;
	palette[78].peFlags = PC_NOCOLLAPSE;

	palette[79].peRed   = 253;
	palette[79].peGreen = 79;
	palette[79].peBlue  = 79;
	palette[79].peFlags = PC_NOCOLLAPSE;

	palette[80].peRed   = 255;
	palette[80].peGreen = 255;
	palette[80].peBlue  = 255;
	palette[80].peFlags = PC_NOCOLLAPSE;

	// now fill in entry 0 and 255 with black and white
	palette[0].peRed   = 0;
	palette[0].peGreen = 0;
	palette[0].peBlue  = 0;
	palette[0].peFlags = PC_NOCOLLAPSE;

	palette[255].peRed   = 255;
	palette[255].peGreen = 255;
	palette[255].peBlue  = 255;
	palette[255].peFlags = PC_NOCOLLAPSE;

	// create the palette object
	if (FAILED(lpdd7->lpVtbl->CreatePalette(lpdd7, DDPCAPS_8BIT | DDPCAPS_ALLOW256, 
                                palette, &lpddpal, NULL)))
		return(0);

	// finally attach the palette to the primary surface
	if (FAILED(lpddsprimary->lpVtbl->SetPalette(lpddsprimary, lpddpal)))
		return(0);

///////DirectInput Stuff/////
//added & before IID_IDirectDraw7
	// first create the direct input object
	if (FAILED(DirectInputCreateEx(hinstance_app,DIRECTINPUT_VERSION,
					    &IID_IDirectInput7, (void**)&lpdi,NULL)))
		return(0);
	// create a mouse device  /////////////////////////////////////
	if (FAILED(lpdi->lpVtbl->CreateDeviceEx(lpdi, &GUID_SysMouse, &IID_IDirectInputDevice7,
						(void**)&lpdimouse, NULL)))
		return(0);

	// set cooperation level
	if(FAILED(lpdimouse->lpVtbl->SetCooperativeLevel(lpdimouse, main_window_handle, 
						DISCL_NONEXCLUSIVE | DISCL_BACKGROUND)))
		return(0);

	// set data format
	if(FAILED(lpdimouse->lpVtbl->SetDataFormat(lpdimouse, &c_dfDIMouse)))
		return(0);

	// acquire the mouse
	lpdimouse->lpVtbl->Acquire(lpdimouse);
/////////////////////////////////////
	// Create a DI7 object for the keyboard
   	if(FAILED(lpdi->lpVtbl->CreateDeviceEx(lpdi, &GUID_SysKeyboard, &IID_IDirectInputDevice7, (void**)&lpdikey, NULL))) 
		return(0);   

    // Set the data format for the keyboard
    if(FAILED(lpdikey->lpVtbl->SetDataFormat(lpdikey, &c_dfDIKeyboard)))
		return(0);

    // Set the cooperative level for the keyboard
    if(FAILED(lpdikey->lpVtbl->SetCooperativeLevel(lpdikey, main_window_handle, DISCL_FOREGROUND |
                                                       DISCL_NONEXCLUSIVE)))
		return(0);

    // Acquire the keyboard
    lpdikey->lpVtbl->Acquire(lpdikey);

/////////////////////////////////////////////////////////////////

	// set the global mouse position
	mouse_x = SCREEN_WIDTH/2;
	mouse_y = SCREEN_HEIGHT/2;

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsprimary, 0);
	DDraw_Fill_Surface(lpddsback, 0);

	//Load the last used savename
	LoadSaveName();
	//Load the last used loadname
	LoadLoadName();
	//Load the last image size
	LoadWideHigh();

	// return success or failure or your own return code here
	return(1);

} // end Game_Init
/////////////////////////////////////////////////////////////

int Game_Shutdown(void)
{
	// this is called after the game is exited and the main event
	// loop while is exited, do all you cleanup and shutdown here

	// Save the last savename
	WriteSaveName();
	//Save the last loadname
	WriteLoadName();
	//Save the last image size
	WriteWideHigh();

	// first unacquire the keyboard
	lpdikey->lpVtbl->Unacquire(lpdikey);
	// now release the keyboard
	lpdikey->lpVtbl->Release(lpdikey);
	lpdikey = NULL;

	// then unacquire the mouse
	lpdimouse->lpVtbl->Unacquire(lpdimouse);
	// now release the mouse
	lpdimouse->lpVtbl->Release(lpdimouse);
	lpdimouse = NULL;
	// release directinput
	lpdi->lpVtbl->Release(lpdi);
	lpdi = NULL;

	// first the palette
	if (lpddpal)
		{
		lpddpal->lpVtbl->Release(lpddpal);
		lpddpal = NULL;
		} // end if

	//then the backbuffer
	if(lpddsback)
		{
		lpddsback->lpVtbl->Release(lpddsback);
		lpddsback = NULL;
		}
	// now the primary surface
	if (lpddsprimary)
		{
		lpddsprimary->lpVtbl->Release(lpddsprimary);
		lpddsprimary = NULL;
		} // end if

	lpdd7->lpVtbl->RestoreDisplayMode(lpdd7);

	// now blow away the IDirectDraw4 interface
	if (lpdd7)
		{
		lpdd7->lpVtbl->Release(lpdd7);
		lpdd7 = NULL;
		} // end if

	// return success or failure or your own return code here
	return(1);

} // end Game_Shutdown

// WINMAIN ////////////////////////////////////////////////
int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

	WNDCLASSEX winclass; // this will hold the class we create
	HWND	   hwnd;	 // generic window handle
	MSG		   msg;		 // generic message
	//HDC        hdc;      // graphics device context

	// first fill in the window class stucture
	winclass.cbSize         = sizeof(WNDCLASSEX);
	winclass.style			= CS_DBLCLKS | CS_OWNDC | 
	                         CS_HREDRAW | CS_VREDRAW;
	winclass.lpfnWndProc	= WindowProc;
	winclass.cbClsExtra		= 0;
	winclass.cbWndExtra		= 0;
	winclass.hInstance		= hinstance;
	winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
	winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	winclass.lpszMenuName	= NULL;
	winclass.lpszClassName	= WINDOW_CLASS_NAME;
	winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

	// save hinstance in global
	hinstance_app = hinstance;

	// register the window class
	if (!RegisterClassEx(&winclass))
		return(0);

	// create the window
	if (!(hwnd = CreateWindowEx(0,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    "DirectDraw Test for Game", // title
						    WS_POPUP | WS_VISIBLE,  
					 	    0,0,	  // initial x,y
						    SCREEN_WIDTH, SCREEN_HEIGHT, // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
	return(0);

	// save main window handle
	main_window_handle = hwnd;

	// initialize game here
	Game_Init();

	Game_Main();

	Game_Shutdown();

	// return to Windows like this
	return(msg.wParam);

} // end WinMain

///////////////////////////////////////////////////////////
